%
% Aplicacao do metodo de Newton para a resolucao do sistema
% de equacoes nao lineares F(x) = 0.
%
% L. N. Vicente, Setembro de 2004.
%
%
x     = pontoinicial;
F     = Funcao(x);
normF = norm(F);
%
k = 0;
disp('-------------------------------------------------------------------');
disp('                 Metodo de Newton para F(x) = 0                    ');
disp('-------------------------------------------------------------------');
%disp(' Iteracao         x(1)                   x(2)           norma(F(x))');
disp(' Iteracao     |x(1)-x*(1)|           |x(2)-x*(2)|        || x-x* ||');
    sol     = [ sqrt(2)/2 ; sqrt(2)/2 ];
    e(1)    = abs(x(1) - sol(1));
    e(2)    = abs(x(2) - sol(2));
    normsol = norm( x - sol );
disp(sprintf('    %2.0f   %20.16f   %20.16f    %9.4e',k,e(1),e(2),normsol));
%
while (normF > 1e-10) 
%  
    J     = Jacobiana(x);
    p     = - J \ F;
    x     = x + p;
    F     = Funcao(x);
    normF = norm(F);
    k     = k + 1;
%
    sol     = [ sqrt(2)/2 ; sqrt(2)/2 ];
    e(1)    = abs(x(1) - sol(1));
    e(2)    = abs(x(2) - sol(2));
    normsol = norm( x - sol );
    disp(sprintf('    %2.0f   %20.16f   %20.16f    %9.4e',k,e(1),e(2),normsol));
%
end
%
disp('-------------------------------------------------------------------');
%
% Fim.